# +++++++++++++++++++++++++++++++++++++++++++++++++++++++
# AB: maj en oct 2005
# ++++++++++++++++++++++++++++++++++++++++++++++++++++


# ++++++++++++++++++++++++++++++++++++++++++++++++++++
# LES MTHODES 'listpoly'
# ++++++++++++++++++++++++++++++++++++++++++++++++++++
# -----------------------------------------------------
# range.listpoly: Dtermine les min et max 
# des coordonnes de tous les poly d'un objet 'listpoly'
#  l'aide de ma fonction 'range.poly'
# Arguments:
# - un objet de classe 'listpoly'
# - une liste variable d'arguments qui seront passs tels quels
#   'range.poly'
# -----------------------------------------------------
range.listpoly <- function(x, ...) {
  xrange <- yrange <- c(NULL, NULL)

  for (l in x) {
    xrange <- range(xrange, l[,"xcoord"],...)
    yrange <- range(yrange, l[,"ycoord"],...)
  }
  retour <- cbind(xrange,yrange)
  dimnames(retour) <- list(c("lower","upper"),c("xrange","yrange"))
  return(retour)
}

# -----------------------------------------------------
# Les fonctions graphiques
# -----------------------------------------------------

# -----------------------------------------------------
# plot.listpoly: Plot de tous les 'poly' d'un 'listpoly'
# sur le mme cadre, chacun dans une couleur diffrente
#  l'aide de ma fonction 'plot.poly'
# Arguments:
# - un objet de classe 'listpoly'
# - add, si T, on ne trace pas le cadre
#  (pour utilisation aprs un zoom, par ex)
# - une liste variable d'arguments qui seront passs tels quels
#   'plot.poly'
# Si un device graphique est ouvert, le dessin est fait sur celui-ci,
# sinon un device X11 est ouvert
# Exemple:
# plot(parc)
# zoom() -> cliquer sur 2 points
# plot(parc, add=T)
# -----------------------------------------------------
plot.listpoly <- function(x, add=FALSE, color=TRUE, ...) {
listpoly=x

## Ouvrir X11 en rajoutant des couleurs
# si aucun device encore ouvert
# AB: 21/11/2005 Pas besoin: c'est automatique et comme colortype
  # ne marche pas avec R.2., je l'te
#  if (dev.cur() == 1) X11(colortype="pseudo.cube" )

# Pour recentrer en zero
  l <- range(listpoly)



# 12/11/2007: lapply ne marche plus
# Remplacement de ceci par la boucle qui suit:
# ###
# ###  listpoly <- lapply(x, function(a) {
# ### a[,1]=a[,1]-l["lower","xrange"]; 
# ### a[,2]=a[,2]-l["lower","yrange"]; 
# ### return(a)
# ### })

listpoly <-x
for (xl in 1:length(x))
{
listpoly[[xl]][,1]= listpoly[[xl]][,1]-l["lower","xrange"];
listpoly[[xl]][,2]= listpoly[[xl]][,2]-l["lower","yrange"];
}




  class(listpoly) <- "listpoly"
if (add == FALSE) {
# Pour avoir la mme chelle sur les 2 axes:

  l <- range(listpoly)
  etendue <- max(apply(l,2,diff))

# Trac du cadre: (pty='s' => un carr)
  par(pty="s")
  plot( x=c(l[1,"xrange"], l[1,"xrange"]+etendue),
       y=c(l[1,"yrange"], l[1,"yrange"]+etendue),
       type="n", xlab="", ylab="")
} # fin (add == FALSE)

if(color==TRUE) {
# Crer les couleurs:
  lg <- length(listpoly)
  r <- rainbow(lg)
  for (i in 1:lg) 
    attr( listpoly[[i]], "couleur") <- r[i]
}

# Boucle sur les poly:

# 12/11/2007: lapply ne marche plus
# Remplacement de ceci par la boucle qui suit:
# ###  lapply(listpoly, plot.poly, add=T, ...)
for (xl in 1:length(listpoly))
    plot.poly(listpoly[[xl]], add=TRUE, ...)


# Rajout du no de poly:
  for (i in 1:length(listpoly)) {
    text(x=mean(listpoly[[i]][,1]),
	 y=mean(listpoly[[i]][,2]),
	 labels=names(listpoly[i]))
  }

  invisible()
}
# -----------------------------------------------------
# ---------------------------------------------------------
# Fonction:
# Ecrire sur fichier un 'listpoly' selon le format:
#npoly
# pour chaque poly i, 2 lignes:
# son identificateur suivi des x-coordonnes
# son identificateur suivi des y-coordonnes
# ---------------------------------------------------------

export <- function(x, filename)
  UseMethod("export")

export.default <- function(x,filename)
  {
  if (!inherits(x,"listpoly"))
    stop("This function is valid only on a 'listpoly' object.")
  }
# -----------------------------------
export.listpoly = function(x, filename) {
  l = length(x)
  sink(filename)
  cat(l)
  cat("\n")
  for (i in 1:l) {
    cat(i); cat("  ");cat(x[[i]][,1]); cat("\n");
    cat(i); cat("  ");cat(x[[i]][,2]); cat("\n");
  }
  sink()
  invisible()
}

