\name{crdiff}
\alias{crdiff}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ View differences between two result-files.}
\description{
  Display the differences greater than given
  thresholds, between values read on two result-files
  created by CaliFloPP or RCALI. 
  The polygons couples need to be  identical on the both files,
  and the configuration variable
  OUTPUT_FILE_FORMAT needs to be equal to FLOW on the configuration
  file of  CaliFloPP or RCALI. 
  Optionally, this function plots the polygons where differences are observed
  on PostScript files.
}
\usage{
crdiff (fileres1, fileres2,
  ival=c(3,4, 10, 11, 15, 16),
  mdiff=c(1.0e-4,1.0e-4, 10, 1, 10,1), 
  datafile=NULL, format=1,  delim = " ", plotfile="diff",
  igr=c(3,4), ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fileres1}{ Name of the first result-file.}
  \item{fileres2}{ Name of the second result-file.}
  \item{ival}{ Vector of the indexes of the values to be compared.
  If a value of 'ival' is greater than the number of values read on the
  files, a warning is issued and the value is ignored.}
  \item{mdiff}{ Vector of same length as 'ival' equal to the
    corresponding thresholds.}
  \item{datafile}{ Optionally, the name of the polygons file.
    When set, Postscript files are created; on each one,
    the parcels are plot, the one where differences have been observed
    is in pink, its partners are in blue.
    The following arguments are taken into account if \code{datafile} is
    set, only.}
  \item{format}{ Format of the datafile; should be 1 or 2.}
  \item{delim}{ Separator character on the polygons-file }
  \item{plotfile}{ Prefix of the PostScript files.}
  \item{igr}{  Vector for the plots; its values should be in 'ival';
    for each value i of igr,
    differences between the 'ival[igr[i]]' values are plotted.}
    \item{\dots}{ Arguments to be passed to the function 'plot'}
}
\value{
  A list, with components:
  \item{call }{ Creation command. }
  \item{v }{ Matrix with four columns:
    the identificators of the two polygons where differences greater
    than the threshold have been observed, the values read on each files
    and the difference between them.
    As many lines as pairs of polygons where they are differences.

    They are as many components 'v' as value in 'ival'
    The name 'v' is suffixed by the corresponding value of 'ival'.
  }
  }
\author{ MIA-Jouy }
\keyword{utilities}
